main()
	{
	wait 1;

	// for GERMANS and others:
	// the comments are in english to make them available to a wider audience.
	// since all germans learn english from fifth class and i'm german too
	// you should be able to read the english comments
	// if you don't understand english it's very likely you won't understand what this script does

	// "Unwissenheit ist temporr wohingegen Doofheit ein Dauerzustand ist"

	// here we go...
	// The 4 Ghost are:
	ROT = getent("geist_ROT","targetname");
	PINK = getent("geist_PINK","targetname");
	CYAN = getent("geist_CYAN","targetname");
	ORANGE = getent("geist_ORANGE","targetname");

	// and they make these sounds: (see soundaliases\pacman_deluxe.csv for detail)
	ROT playloopsound ("ghost4");
	PINK playloopsound ("ghost1");
	CYAN playloopsound ("ghost2");
	ORANGE playloopsound ("ghost3");

	// Hide the ghosts at the begin of level
	ROT hide();
	PINK hide();
	CYAN hide();
	ORANGE hide();

	// these are the "paths" the ghosts walk
	// they are defined by script-origins with the names "geist_ROT_WP" etc.
	// the waypoints MUST NOT differ in x AND y coordinates
	// only differ in x while y is constant vice versa.
	// otherwise it becomes hard to determine which direction the ghosts look...

	level.Waypoints[0] = getentarray("geist_ROT_WP","targetname");
	level.Waypoints[1] = getentarray("geist_PINK_WP","targetname");
	level.Waypoints[2] = getentarray("geist_CYAN_WP","targetname");
	level.Waypoints[3] = getentarray("geist_ORANGE_WP","targetname");
	level.Waypoints[4] = getentarray("FREE_WP_1","targetname");
	level.Waypoints[5] = getentarray("FREE_WP_2","targetname");
	level.Waypoints[6] = getentarray("FREE_WP_3","targetname");


	// Enter the ghosts: Geist_wandern(IntegerSpeed (1 to unlimited), IntegerPath (0 to size of level.Waypoints)
	wait 2;
	PINK thread Geist_wandern(100, 1);

	wait 2;
	CYAN thread Geist_wandern(200, 2);


	wait 2;
	ORANGE thread Geist_wandern(300, 3);


	wait 2;
	ROT thread Geist_wandern(400, 0);

	}

Geist_wandern(iSpeed, myPfad)
	{
	// iSpeed is the speed of the ghost
	// myPfad is the NUMBER of the path the ghost follows
	myWaypoints = level.Waypoints[myPfad];

	//start at 1st waypoint
	iWaypoint = 0;

	// next waypoint
	tempZiel = myWaypoints[iWaypoint].origin;
	self.origin = tempZiel;
	self show();
	while(1)
		{
		iWaypoint += 1;

		// check if path is at end
		if (iWaypoint >= myWaypoints.size)
			{
			// end of path reached, we need to reset waypointcounter and
			// get a new path:
			oldPfad = myPfad;

			// get a new path from level.Waypoints array:
			// deactivate it and the ghosts always take the same path they're given on init
			while(oldPfad == myPfad)
				{
				// just to make sure that we don't get the same path as before:
				myPfad = randomint(7);
				}
			myWaypoints = level.Waypoints[myPfad];

			//reset waypointcounter:
			iWaypoint = 0;

			}

		// next waypoint:
		tempZiel = myWaypoints[iWaypoint].origin;

		// according to it's speed,
		// how long does it take our ghost to reach the next waypoint ?
		iZeit = distance(self.origin,tempZiel)/iSpeed;

		// how long does it take our ghost to look into the next direction ?
		//iRotateZeit = 50 / iSpeed;

		// What direction does it look? 
		// Does it move left/right on map (x axis)?
		if (self.origin[0] > tempZiel[0])
			self rotateto((0,90,0), 0.1);
		if (self.origin[0] < tempZiel[0])
			self rotateto((0,270,0), 0.1);

		// Does it move up/down on map (y axis)?
		if (self.origin[1] > tempZiel[1])
			self rotateto((0,180,0), 0.1);
		if (self.origin[1] < tempZiel[1])
			self rotateto((0,0,0), 0.1);
		// just for info - z axis would be: self.origin[2]

		self moveto(tempZiel, iZeit, 0.0, 0.0);
		wait iZeit;
		
		// if the ghost gets stuck between player and a wall it is SET to its next waypoint after the time he would have taken to reach it
		self.origin = tempZiel;
		}
	}

