main()
	{
	precacheFX();
	ambientFX();
	faesser_explodieren();
 	}

precacheFX()
	{
	level._effect["feuerstelle"] = loadfx ("fx/fire/pacman_benzinfass.efx");
	level._effect["benzinfassboom"] = loadfx ("fx/fire/pacman_benzinfass_explosion.efx");
	}

ambientFX()
	{
	// these are the burning barrels that make the lighting of the map reasonable

	iBrandstelle = 0;
	// i set up script-origins for the fx rather than entering coodinates like (3242,674,123)
	// so it's easier to add flames and you don't have to open the scripts again, since they bring their own origin :-)

	// follow these steps:
	
	// 1 import an xmodel for the barrel
	// 2 create a script-origin right above
	// 3 create a trigger_damage around the barrel
	// 4 select the three entities
	// 5 copy, paste and move to destination until you have as much burning barrels as you like

	brandstellen = getentarray("HIER_BRENNT_ES", "targetname");

	// this lights the barrels
	while (iBrandstelle < brandstellen.size)
		{
		tempOrigin = brandstellen[iBrandstelle].origin;
		maps\mp\_fx::loopfx("feuerstelle", tempOrigin, 0.5, (0,0,0));
		maps\mp\_fx::soundfx("smallfire", tempOrigin);
		iBrandstelle += 1;
		}
	}

faesser_explodieren()
	{
	iFass = 0;
	faesser = getentarray("fassdamage", "targetname");
	
	while (iFass < faesser.size)
		{
		// this "arms" the barrels, each barrel has a trigger_damage to receive damage and tell the script to start the explosion.
		faesser[iFass] thread benzinfass_damaged(iFass);
		iFass += 1;
		}
	}

benzinfass_damaged(iFassNummer)
	{
	// here we use the script-origins for the flames again
	// to determin the location of the explode-fx
	brandstellen = getentarray("HIER_BRENNT_ES", "targetname");
	while(1)
		{
		// do nothing until some idiot shoots you...
		self waittill ("damage");

		//here we go:
		playfx(level._effect["benzinfassboom"], brandstellen[iFassNummer].origin);
		brandstellen[iFassNummer] playsound ("explo_radio");
		oTemp = brandstellen[iFassNummer].origin;

		// people around exploding barrel receive damage
		radiusDamage(oTemp , 200, 300, 30);

		wait(10);
		}
	}
