main()
{

	// stuff that every level needs:
	game["allies"] = "british";
	game["axis"] = "german";
	game["attackers"] = "allies";
	game["defenders"] = "axis";
	game["british_soldiertype"] = "africa";
	game["german_soldiertype"] = "africa";

	// wonder what THIS is - just copied it...
	setcvar("r_glowbloomintensity0","0");
	setcvar("r_glowbloomintensity1","0");
	setcvar("r_glowskybleedintensity0","0");

	// this precaches the explosion of the radio
	level._effect["radiopuff"] = loadfx ("fx/props/radio_explosion.efx");

	// start the arcade-soundloop
	ambientPlay("ambient_mp_pacman");

	// light the barrels and arm them
	maps\mp\mp_pacman_fx::main();

	// make the ghosts mova around
	maps\mp\ghosts::main();

	// start the level...
	maps\mp\_load::main();

		
	level.radioplay = false;
	radioschalter = getent("radioswitch", "targetname");
	radioschalter thread radio_einschalt();
	level.currentplayeronradio = false;
	level.radioplaytime = 0;
	
	level.radioloop[0] = "pacmanfever";
	level.radioloop[1] = "donkeykong";
	level.radioloop[2] = "hyperspace";
	level.radioloop[3] = "frogger";
	level.radioloop[4] = "moon_patrol";
	
	level.sCurrentRadioloop = level.radioloop[0];
	level thread radio_score();
	}


radio_einschalt() 
	{
	myRadio = getent ("radioswitch","targetname");
	level.radioswitchorigin = myRadio.origin;
	myRadio thread radio_think();
	}

radio_think()
	{
	while (1)
		{
		self waittill ("trigger", player_radio);
		level.currentplayeronradio = player_radio;
		if (!level.radioplay)
			{
			level.radioplay = true;
			getent ("lautsprecher", "targetname") playsound ("slide_advance");
			iprintln(player_radio.name + " has taken the radio and gets 1 bonus-kill every 5 seconds");
			radio_play();
			}
		}
	} 

radio_play()
	{
	my_lautsprecher = getent ("lautsprecher", "targetname");
	my_lautsprecher playloopsound (level.sCurrentRadioloop);
	level.radioplaytime = 60;
	my_switch = getent ("radioswitch", "targetname");
	my_switch.origin = (-64, 0, 2000);
	getent("radiodamage","targetname") thread radio_damaged();
	}


radio_score()
	{
	while (1)
		{

		if (level.radioplaytime > 0)
			{
			iTemp = level.currentplayeronradio.score;
			iTemp = iTemp + 1;
			level.currentplayeronradio.score = iTemp;
			iprintln("Bonus-kill for " + level.currentplayeronradio.name);
			level.radioplaytime -= 5;
			}

		if (level.radioplaytime <= 0)
			{
			if (level.currentplayeronradio)
				{
				radio_stop();
				}
			}

		wait (5);
		}
	}

radio_stop()
	{
	// this will be deleted when i figure out how to "or" in if-clauses!!!
	fakeor = 0;
	if (level.radioplaytime != 0)
		{fakeor++;}
	if (level.currentplayeronradio != false)
		{fakeor++;}
	if (fakeor != 0)
		{
		level.radioplaytime = 0;
		level.currentplayeronradio = false;
	
		my_lautsprecher = getent ("lautsprecher", "targetname");
		my_lautsprecher stoploopsound ();
		my_lautsprecher playsound ("explo_radio");
	
		oTemp = getent("RADIO_BRENNT","targetname");
		playfx(level._effect["radiopuff"], oTemp.origin);
	
		level.radioplay = false;
		level.currentplayeronradio = false;
	
		iprintln("Radio will be operative in 30 seconds!");
		wait(30);
	
		// place the switch back where it belongs
		my_switch = getent ("radioswitch", "targetname");
		my_switch.origin = level.radioswitchorigin;
		
		sOldRadioloop = level.sCurrentRadioloop;
		while (sOldRadioloop == level.sCurrentRadioloop)
			{
			iNew = randomint(4);
			level.sCurrentRadioloop = level.radioloop[iNew];
			}
		}
	}


radio_damaged()
	{
	// the radio has suffered damage from a bullet or splash-damage from a grrenade or melee-attack
	while(level.radioplay == true)
		{
		self waittill ("damage");
		radio_stop();
		}
	}


